<template>
  <div
    ref="container"
    class="select"
    :class="{
      'select--is-focused': isFocused,
    }"
    :style="{
      width,
      height,
    }"
    :tabindex="0"
    @focus="focus"
    @blur="popupBlur"
  >
    <div
      class="select__container"
      :class="{
        [`input__container--state-${state}`]: !!state
      }"
    >
      <div class="select__before">
        <slot name="before" />
      </div>
      <div
        class="select__content"
      >
        <label
          v-if="isAutocomplete && isFocused"
          class="select__query"
        >
          <input
            ref="input"
            v-model="query"
            :placeholder="placeholder"
            @focus="focus"
            @blur="popupBlur"
          >
        </label>
        <fragment v-else>
          <div
            v-if="placeholder && !valueLabel"
            class="select__placeholder"
          >
            {{ placeholder }}
          </div>
          <div
            v-if="valueLabel"
            class="select__value"
          >
            {{ valueLabel }}
          </div>
        </fragment>
      </div>
      <div class="select__after">
        <slot name="after">
          <Icon
            type="caret-down"
            size="lt"
          />
        </slot>
      </div>
    </div>
    <div
      ref="popup"
      class="select__popup"
      :class="{
        'select__popup--is-active': isFocused,
      }"
    >
      <div
        v-if="computedData.length"
        class="select__options"
      >
        <div
          v-for="option in computedData"
          :key="option.key"
          class="select__option"
          :class="{
            'select__option--is-selected': option.key === value
          }"
          :tabindex="0"
          @click="setOption(option.key)"
        >
          <div
            v-if="option.hint"
            class="select__option-hint"
          >
            {{ option.hint }}
          </div>
          <span class="select__option-label">
            {{ option.text }}
          </span>
        </div>
      </div>
      <div
        v-else
        class="select__options-hint"
      >
        {{ $t('select.empty') }}
      </div>
    </div>
  </div>
</template>

<script>
import formFieldMixin from '../formFieldMixin';
import Icon from '../../icon/Icon';

export default {
  name: 'FormSelect',
  components: { Icon },
  mixins: [formFieldMixin],
  props: {
    isAutocomplete: Boolean,
    queryTimeout: {
      type: Number,
      default: 250,
    },
    data: {
      type: Array,
      default: () => [],
    },
    blurOnInput: {
      type: Boolean,
      default: true,
    },
  },
  data() {
    return {
      query: '',
      queryTimeoutInstance: null,
    };
  },
  computed: {
    computedData() {
      return (
        Array.isArray(this.data)
          ? this.data
          : Object.entries(this.data)
            .map(([key, text]) => ({ key, text }))
      ).map(
        (item) => (typeof item === 'string' ? ({ key: item, text: item }) : item),
      );
    },
    valueObject() {
      return this.computedData.find(({ key }) => key === this.value);
    },
    valueLabel() {
      return (this.valueObject || {}).text || '';
    },
  },
  watch: {
    query(query) {
      if (this.queryTimeoutInstance) {
        clearTimeout(this.queryTimeoutInstance);
      }

      this.queryTimeoutInstance = setTimeout(() => {
        this.$emit('query', query);
      }, this.queryTimeout);
    },
  },
  methods: {
    popupBlur({ relatedTarget }) {
      const { popup } = this.$refs;

      if (popup === relatedTarget || popup.contains(relatedTarget)) {
        return;
      }

      this.blur({ relatedTarget });
    },
    setOption(value) {
      this.setValue(value);

      if (this.blurOnInput) {
        this.blur();
      } else {
        this.focus();
      }
    },
  },
};
</script>

<style lang="scss">
  @import "./select";
</style>
